unit FixTabPage;

interface

uses
  Windows, Messages, ComCtrls, Graphics;

 type
   TPageControlFix = class(TPageControl)
   private
    procedure WMEraseBkGnd(var Message: TWMEraseBkGnd); message WM_ERASEBKGND;
   end;

procedure Register;

implementation

uses Classes;

{ TPageControlFix }

procedure TPageControlFix.WMEraseBkGnd(var Message: TWMEraseBkGnd);
var
  ARect:TRect;
begin
    Canvas.Brush.Color:=Color;
    FillRect(Message.DC,ClientRect,Canvas.Brush.Handle);
    ARect:=ClientRect;
    ARect.Top:=0;
    ARect.Bottom:=DisplayRect.Top-2;
    Canvas.Pen.Color:=clGrayText;
    SelectObject(Message.DC,Canvas.Pen.Handle);
    MoveToEx(Message.DC,ARect.Left+1,ARect.Bottom,nil);
    LineTo(Message.DC,ARect.Right-1,ARect.Bottom);

    Message.Result := 1;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TPageControlFix]);
end;


end.
