unit wsFileOp;

interface

uses Windows, SysUtils;


function FileExists2(const F:widestring):boolean;
function DirectoryExists2(const F:widestring):boolean;
function GetLongPathOfW(const AFileName: widestring): widestring;


implementation

function GetLongPathOfW(const AFileName: widestring): widestring;
  function GetLongNameOf(const AFilePath: widestring): widestring;
  var
    SearchRec: TSearchRec;
  begin
    if Length(AFilePath) = 3 then//hCûw肳ꂽ
    begin
      Result := CharUpperW(PWChar(AFilePath));
    end
    else begin
      if FindFirst(AFilePath, faAnyFile, SearchRec) = 0 then
      begin
        //AFilePathƂ
        Result := IncludeTrailingPathDelimiter(GetLongNameOf(
          ExtractFileDir(AFilePath))) + SearchRec.Name;
      end
      else begin
        if (Length(AFilePath) >= 2) and (AFilePath[1] = '\') and (AFilePath[2] = '\') then
        Result :=  AFilePath else//\\w肳ꂽ
        Result := '';
      end;
      FindClose(SearchRec);
    end;
  end;

begin
  Result := '';
  if FileExists(AFileName) then
  begin
    Result := GetLongNameOf(ExpandFileName(AFileName));
    //vista΍
    //FindFirstȂtH_
    if not FileExists(Result) then Result := AFileName;
  end;
end;

Function IsDriveReady( drive:WChar ) : Boolean;
Var
  oldmode   : word;
  searchrec : TSearchRec;
Begin
  if drive='\' then begin
    Result:=true;
    exit;
  end;
  drive   := CharUpperW(PWChar(WideString( drive )))^;
  oldmode := SetErrorMode( SEM_FAILCRITICALERRORS );  (* G[ *)
  try //ׂ?
    result  := DiskSize( ord( drive )-$40 )<>-1;
    if result and ( GetDriveTypeW( pWchar( widestring(drive+':\' )) ) in [DRIVE_REMOTE,DRIVE_CDROM] ) then begin
      try
        result := FindFirst( drive+':\*.*',$3f,searchrec )=0;
      finally
        FindClose( searchrec );
      end;
    end;
  finally
    SetErrorMode( oldmode );
  end;                            (* ʏ폈 *)
End;

function FileExists2(const F:widestring):boolean;
begin
  if Length(f)=0 then Result:=false else begin
    if (ExpandFileName(f)[1] = '\') or
      IsDriveReady(ExpandFileName(f)[1]) then Result:=FileExists(f) else Result:=false;
  end;//
end;

function DirectoryExists2(const F:widestring):boolean;
begin
  if Length(f)=0 then Result:=false else begin
    if (ExpandFileName(f)[1] = '\') or
      IsDriveReady(ExpandFileName(f)[1]) then Result:=DirectoryExists(f) else Result:=false;
  end;//
end;


end.
