﻿//編集中のテキスト内文字数をカウントするサンプルです

//エディタから全文取得
var s = new String(Editor.Text);

//変数を宣言し初期値ゼロにセット
var mSbSpace = 0;
var mDbSpace = 0;
var mTab = 0;
var mCR = 0;
var mLF = 0;
var mCRLF =0;
var mOther = 0;

//CRLFを検出した場合のフラグ
var Skip = false;

//一文字ずつチェックし、該当する変数を増やす
for (var i = 0; i < s.length; i ++)
{
	if (Skip)
	{
		Skip = false;
	}
	else
	{
		switch (s.charCodeAt(i))
		{
			case 0x20:
				mSbSpace ++;
				break;
			case 0x3000:
				mDbSpace ++;
				break;
			case 9:
				mTab ++;
				break;
			case 0xD:
				if (i < s.length - 1)
				{
					if (s.charCodeAt(i + 1) == 10)
					{
						mCRLF ++;
						Skip = true;
					}
					else mCR ++;
				}
				else mCR ++;
				break;
			case 0xA:
				mLF ++;
				break;
			default:
				mOther ++;
		}
	}
}
mCRLF += mCR + mLF;
//結果をダイアログボックスで表示するため文字列として並べる
var m = "半角スペース  :  " + mSbSpace + "\r\n" +
		"全角スペース  :  " + mDbSpace + "\r\n" +
		"タブ文字(\\t)  :  " + mTab + "\r\n" +
		"改行           :  " + mCRLF + "\r\n" +
		"その他の文字  :  " + mOther + "\r\n";

//モーダルなダイアログボックス表示
Mana.AlertDialog(m);
